/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2014 Frederik Heber. All rights reserved.
 *
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * SphericalPointDistribution.cpp
 *
 *  Created on: May 30, 2014
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include "SphericalPointDistribution.hpp"

#include "CodePatterns/Assert.hpp"
#include "CodePatterns/Log.hpp"

#include <algorithm>
#include <vector>

#include "LinearAlgebra/Line.hpp"
#include "LinearAlgebra/RealSpaceMatrix.hpp"
#include "LinearAlgebra/Vector.hpp"

void SphericalPointDistribution::initSelf(const int _NumberOfPoints)
{
  switch (_NumberOfPoints)
  {
    case 0:
      points = get<0>();
      break;
    case 1:
      points = get<1>();
      break;
    case 2:
      points = get<2>();
      break;
    case 3:
      points = get<3>();
      break;
    case 4:
      points = get<4>();
      break;
    case 5:
      points = get<5>();
      break;
    case 6:
      points = get<6>();
      break;
    case 7:
      points = get<7>();
      break;
    case 8:
      points = get<8>();
      break;
    case 9:
      points = get<9>();
      break;
    case 10:
      points = get<10>();
      break;
    case 11:
      points = get<11>();
      break;
    case 12:
      points = get<12>();
      break;
    case 14:
      points = get<14>();
      break;
    default:
      ASSERT(0, "SphericalPointDistribution::initSelf() - cannot deal with the case "
          +toString(_NumberOfPoints)+".");
  }
  LOG(3, "DEBUG: Ideal polygon is " << points);
}

